Imports Microsoft.AnalysisServices.AdomdClient


Public Class ADOMDWrapper
    Public Function BuyingByProductByStoreByYearMDX(ByRef CityName As String) As CellSet
        Dim conn As AdomdConnection
        Dim cmd As AdomdCommand
        Dim cst As CellSet
        Dim strServer As String = "BLARSONXP2\BMLSQL2005"
        Dim strDatabase As String = "MaxMinSalesDM"
        Dim strMDXQuery As String = "SELECT [Time].[Year].members ON PAGES, [Store].[Store Name].members ON ROWS, [Product].[Brand Name].members ON COLUMNS FROM [MaxMinSales] WHERE ([Measures].[Unit Sales], [Customer].[City].[" & CityName & "])"


        ' Open the connection to the Analysis Services server
        Try
            ' Create a new AdomdConnection object, providing the connection
            ' string.
            conn = New AdomdConnection("Data Source=" & strServer & _
            ";Catalog=" & strDatabase & ";Provider=msolap;")
            ' Open the connection.
            conn.Open()
        Catch ex As Exception
            Throw New ApplicationException( _
                "An error occurred while connecting.")
        End Try

        ' Execute the MDX Query
        Try
            ' Create a new AdomdCommand object, providing the MDX query string.
            cmd = New AdomdCommand(strMDXQuery, conn)
            ' Run the command and return a CellSet object.
            cst = cmd.ExecuteCellSet()

            ' Return the CellSet object
            Return cst

        Catch ex As Exception
            Throw New ApplicationException( _
                "An error occurred while opening the cellset.")
        End Try

        ' Release resources.
        Try
            conn.Close()
        Catch ex As Exception
            ' Ignore errors
        Finally
            cst = Nothing
            cmd = Nothing
            conn = Nothing
        End Try

    End Function

End Class
